### R code from vignette source 'MP.Rnw'

###################################################
### code chunk number 1: MP.Rnw:634-637
###################################################
library(MiscPsycho)
library(statmod)
options(width=70)


###################################################
### code chunk number 2: MP.Rnw:640-642
###################################################
set.seed(1)
dat <- simRasch(200, 10)


###################################################
### code chunk number 3: MP.Rnw:647-648
###################################################
str(dat)


###################################################
### code chunk number 4: MP.Rnw:659-663
###################################################
itemDat <- dat$data
ff <- as.formula(paste('~', paste( names(itemDat), collapse= "+")))
(aa <- alpha(ff, itemDat))
summary(aa)


###################################################
### code chunk number 5: MP.Rnw:674-676
###################################################
(aa <- classical(ff, data = itemDat))
summary(aa)


###################################################
### code chunk number 6: MP.Rnw:681-684
###################################################
itemDat$group <- gl(10,20)
(aa <- classical(ff, data = itemDat, design = TRUE, group = group))
summary(aa)


###################################################
### code chunk number 7: MP.Rnw:691-694
###################################################
(fm1 <- jml(ff, itemDat, bias = TRUE))
summary(fm1)
coef(fm1)


###################################################
### code chunk number 8: MP.Rnw:701-703 (eval = FALSE)
###################################################
## plot(fm1)
## plot(fm1, all = FALSE, item = 3, pch = 2, lty = 1)


###################################################
### code chunk number 9: MP.Rnw:714-716
###################################################
(ss <- scoreCon(coef(fm1)))
summary(ss)


###################################################
### code chunk number 10: MP.Rnw:725-731
###################################################
alpha <- c(1,2)
beta <- c(0,1)
guess <- c(0,0)
params <- list("3pl" = list(a = alpha, b = beta, c = guess), 
               "gpcm" = NULL)
params


###################################################
### code chunk number 11: MP.Rnw:738-742
###################################################
x <- c(1,0) # correct/incorrect
irt.ability(x, params, ind.dichot = c(1,2), method = "MLE")
irt.ability(x, params, ind.dichot = c(1,2), method = "MAP")
irt.ability(x, params, ind.dichot = c(1,2), method = "EAP")


###################################################
### code chunk number 12: MP.Rnw:747-748
###################################################
irt.ability(x, params, ind.dichot = c(1,2), method = "MAP", control=list(mu=.5, sigma=1.2))


###################################################
### code chunk number 13: MP.Rnw:755-757
###################################################
params <- list("3pl" = list(a = c(1,1), b = c(0, 1), c = c(0,0)),
               "gpcm" = list(a = c(1,1), d = list(item1 = c(0,1,2,3,4), item2 = c(0,.5,1, 1.5))))


###################################################
### code chunk number 14: MP.Rnw:762-766
###################################################
x <- c(0,1,2,2)
irt.ability(x, params, ind.dichot = c(1,2), method = "MLE")
irt.ability(x, params, ind.dichot = c(1,2), method = "MAP")
irt.ability(x, params, ind.dichot = c(1,2), method = "EAP")


###################################################
### code chunk number 15: MP.Rnw:773-778
###################################################
# if all are polytomous
params <- list("3pl" = NULL, "gpcm" = list(a = c(1,1), d = list(item1 = c(0,1,2,3,4), item2 = c(0,.5,1, 1.5))))
irt.ability(c(2,3), params, method = "MLE")
irt.ability(c(2,3), params, method = "MAP")
irt.ability(c(2,3), params, method = "EAP")


###################################################
### code chunk number 16: MP.Rnw:783-787
###################################################
params <- list("3pl" = list(a = rep(1,10), b = coef(fm1), c = rep(0,10)), 
               "gpcm" = NULL)
x <- c(1,1,1,1,1,0,0,0,0,0)
irt.ability(x, params, ind.dichot = c(1:10), method = "MLE", control=list(D = 1))


###################################################
### code chunk number 17: MP.Rnw:794-799
###################################################
tt <- as.list(coef(fm1))
ll <- lapply(tt, function(x) c(0,x))
params <- list("3pl" = NULL, "gpcm" = list(a = rep(1,10), d = ll))
x <- c(1,1,1,1,1,2,2,2,2,2)
irt.ability(x, params, method = "MLE", control=list(D = 1))


###################################################
### code chunk number 18: MP.Rnw:812-815
###################################################
params <- list("3pl" = list(a = c(1,1), b = c(0, 1), c = c(0,0)),
               "gpcm" = list(a = c(1,1), d = list(item1 = c(0,1,2,3,4), item2 = c(0,.5,1, 1.5))))
plaus.val(x = c(0,1,2,2), params = params, ind.dichot = c(1,2))


###################################################
### code chunk number 19: MP.Rnw:820-822
###################################################
aa <- plaus.val(x = c(0,1,2,2), params = params, ind.dichot = c(1,2), PV = 1000)
mean(aa)


###################################################
### code chunk number 20: MP.Rnw:827-828
###################################################
irt.ability(x = c(0,1,2,2), params = params, ind.dichot = c(1,2), method = "EAP")


###################################################
### code chunk number 21: MP.Rnw:837-838
###################################################
posterior(x = c(0,1,2,2), theta = 1, params = params, ind.dichot = c(1,2))


###################################################
### code chunk number 22: MP.Rnw:847-848
###################################################
head(dat$data)


###################################################
### code chunk number 23: MP.Rnw:853-858
###################################################
x <- as.numeric(dat$data[1,])
params <- list("3pl" = list(a = rep(1,10), b = coef(fm1), c = rep(0,10)), 
               "gpcm" = NULL)
rr <- class.acc(x, prof_cut = 0, params = params, ind.dichot = c(1:10), aboveC = TRUE, control=list(D=1))
rr


###################################################
### code chunk number 24: MP.Rnw:863-866
###################################################
x <- as.numeric(dat$data[4,])
rr <- class.acc(x, prof_cut = 0, params = params, ind.dichot = c(1:10), aboveC = FALSE, control=list(D=1))
rr


###################################################
### code chunk number 25: MP.Rnw:873-880
###################################################
a <- c(1.45, 1.84, 2.55, 2.27, 3.68, 4.07, 2.26, 1.87, 2.19, 1.33)
b <- c(-.6, -.82, -1.6, -.87, -1.41, -1.33, -1.16, -.11, -.64, -1.23)
params <- list("3pl" = list(a = a, b = b, c = rep(0, 10)), 
               "gpcm" = NULL)
x <- c(rep(0,9),1)
rr <- irt.ability(x, params, ind.dichot = c(1:10), method = "EAP")
rr


###################################################
### code chunk number 26: MP.Rnw:885-887
###################################################
rr <- class.acc(x, prof_cut = -1.5, params, ind.dichot = c(1:10), aboveC=TRUE)
rr


###################################################
### code chunk number 27: MP.Rnw:896-897
###################################################
tmp <- data.frame(ID = 1:100, mathScore = rnorm(100), readScore = rnorm(100), scienceScore = rnorm(100))


###################################################
### code chunk number 28: MP.Rnw:904-907
###################################################
(result <- SSI(mathScore ~ readScore + scienceScore, tmp, k = 20, id=ID, na.action = na.omit))
summary(result)
head(result$model.frame)


###################################################
### code chunk number 29: MP.Rnw:918-934
###################################################
 NumStu   <- 30
     NumItems <- 50
     dat <- matrix(0, nrow=NumStu, ncol=NumItems) 
     set.seed(1234)
     for(i in 1:NumStu){
        dat[i,] <- sample(1:4, NumItems, replace=TRUE)
     }
dat <- data.frame(dat)
     
## Add in explicit answer copying 
dat[(NumStu+1),] <- dat[NumStu,]
dat[(NumStu+2),] <- c(dat[(NumStu-1), 1:25], dat[(NumStu-2), 26:50 ])
     
## Answer Key
set.seed(1234)
key <- sample(1:4, NumItems, replace=TRUE)


###################################################
### code chunk number 30: MP.Rnw:939-942
###################################################
ff <- as.formula(paste('~', paste( names(dat), collapse= "+")))
## See wrongProb help page
mm <- wrongProb(ff, data = dat, key = key)


###################################################
### code chunk number 31: MP.Rnw:946-948
###################################################
(result <- cheat(ff, data = dat, key = key, wrongChoice = mm))
summary(result)


###################################################
### code chunk number 32: MP.Rnw:957-964 (eval = FALSE)
###################################################
## teachers <- unique(dat$TeacherName)
## result <- numeric(length(teachers))
## for(i in seq_along(teachers)){
## 	tmp <- cheat(~item1 + item2 + item3, dat, wrongChoice = mm, key = key, rfa='bsct', subset=TeacherName==
## 	teachers[i], na.action=NULL)
## 	result[i] <- summary(tmp)$Ncheat
## }


###################################################
### code chunk number 33: MP.Rnw:971-973
###################################################
params1 <- list("3pl" = list(a = c(.4,1.7,1.2), b = c(-1.1, .9,2.2), c = c(.1,.2,.1)), "gpcm" = NULL)
params2 <- list("3pl" = list(a = c(.5,1.6,1), b = c(-1.5, .5,2), c = c(.1,.2,.1)), "gpcm" = NULL)


###################################################
### code chunk number 34: MP.Rnw:978-979
###################################################
SL(params1, params2, control=list(Q=30, mu=0, sigma=1))


###################################################
### code chunk number 35: MP.Rnw:987-988
###################################################
stringMatch('William Clinton', 'Bill Clinton', normalize='NO')


###################################################
### code chunk number 36: MP.Rnw:992-993
###################################################
stringMatch('William Clinton', 'Bill Clinton', normalize='YES')


###################################################
### code chunk number 37: MP.Rnw:997-998
###################################################
stringMatch('Bill Clinton', 'bill Clinton', normalize='YES', case.sensitive = FALSE)


###################################################
### code chunk number 38: MP.Rnw:1003-1004
###################################################
stringMatch('Bill Clinton', 'bill Clinton', normalize='YES', case.sensitive = TRUE)


###################################################
### code chunk number 39: MP.Rnw:1015-1020
###################################################
dat <- data.frame(fname1 = c('Joseph McCall', 'Paul Jones', 'Larry Everett', 'Sam Thompson', 'Sally Fields', 'Doug Carter', 'Bill Friendly', 'Tom Davison', 'Frank Mann', 'Mary Jones'),
     fname2 = c('Joe McCall', 'Paul Jones', 'Barry Everett', 'Samuel Thompson', 'Sally Fields', 'Douglas Carter', 'William Friend', 'Tommy Davison', 'Franklin Mann', 'Cary Jones'))
     
## Randomly sample five names from the data.
stringProbs(dat, N=5)


###################################################
### code chunk number 40: MP.Rnw:1028-1034
###################################################
N <- 5
aa <- simRasch(200,N, mu=0, sigma=1)
tmp <- aa$data
b <- aa$gen
params <- list("3pl" = list(a = rep(1,N), b = b, c = rep(0,N)), "gpcm" = NULL)
colnames(tmp) <- paste('item', 1:5, sep='')


###################################################
### code chunk number 41: MP.Rnw:1039-1042
###################################################
fm1 <- mml(~ item1 + item2 + item3 + item4 + item5, data = tmp, params = params, control=list(D=1, startVal=c(0,1)))
summary(fm1)
coef(fm1)


